#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <errno.h>

#include "prodcust.h"

struct shBuffer *pc_shdata;	 /* data area in the shared memory */

void produtor (void) {
    struct Msg m;
    int i,r;
    int busy;

	for (i=0;i<=(MSGMAX*4);i++) {
		busy = 3000 + (int) (10100.0*rand()/(RAND_MAX+1.0));
		printf ("PROD : Simulating ... Counting down %d\n",busy);
		for (;busy>0;busy--);
		
		sprintf (m.s,"Teste %d",i);
		r = PutSharedData (&m);
		if (r<0){
			printf ("PUT FAILED\n");
			i--;	
		} else
			printf ("PUT = r : %d Msg : %s \n",r,m.s);
		
	}
	SetStop (!FALSE);
}

void consumidor (void) {
   int flag = FALSE;
   struct Msg m;
   int r=0;
   int busy;

  	while (!flag){
		busy = 1 + (int) (5000.0*rand()/(RAND_MAX+1.0));
		printf ("CUST : Simulating ... Counting down %d\n",busy);
		for (;busy>0;busy--);
		
		r = GetSharedData (&m);
		flag = ReadStop();
		if (r<0)
			printf ("GET FAILED - ");
		else
			printf ("GET = r : %d Msg : %s - ",r,m.s);
		printf ("Stop? %d \n",flag);
	}

	do {
		r = GetNotLockSharedMemory (&m);
		printf ("GET = r : %d Msg : %s \n ",r,m.s);
	} while (r>=0);	
		

}


int main (int argc, char **argv) {
pid_t pid;
int code=0;

	printf ("Starting \n ");	
	Start();

	/*criando o segundo processo */ 
	pid = fork();

    	if ( pid == -1 ) { /*Fork failed to create a process */
	        fprintf(stderr,"%s: Failed to fork()\n",strerror(errno));
        	exit(13);

	} else if ( pid == 0 ) { /*This is the child process running */
	        fprintf(stdin,"PID %ld: Child started, parent is %ld.\n", 
        		(long)getpid(),     	/* Our PID */
            		(long)getppid());   	/* Parent PID */
		srand ((unsigned int)getpid()+(unsigned int)getppid());
        	consumidor();
						/* memoria compartilhada deve ser 
						 * liberada em todos os processos */
		
    	} else  { /* This is the parent process running */
        	printf("PID %ld: Started child PID %ld.\n",
            		(long)getpid(),     /* Our PID */
            		(long)pid);         /* Child's PID */
		srand ((unsigned int)getpid());
		produtor ();
		Free();			/* memoria compartilhada deve ser 
					 * liberada em todos os processos */
		exit (0);		
	}



	Free();
	Finalize();
	
}
