/*#include "expat.h"
#include "awtree.h"
*/
#include "awparser.h"

size_t readBuffer (char *buf, size_t len, FILE *file)
{
    size_t readed;
    readed = fread(buf, 1, len, file);
    return readed;
}



void showTree (AwNode *n) {
    AwNode *child;
    AwPair *atr;
    int i;


    for (i = 0; i < AwNode_getLevel(n); i++)  
	    putchar ('\t');
    printf ("%c %s\n",(AwNode_getType(n)==XML_ELEMENT)?'+':' ',AwNode_getInfo(n));
    
    AwNode_resetAttributes(n);
    atr = AwNode_nextAttribute(n);
    while (atr!=NULL) {
        for (i = 0; i < AwNode_getLevel(n); i++)  
	    putchar ('\t');
        printf ("%s=\'%s\'\n",AwPair_getName(atr),AwPair_getValue(atr));
	atr = AwNode_nextAttribute(n);
    }
    
    AwNode_resetChildren (n);
    child = AwNode_nextChild(n);
    while (child!=NULL) {
        showTree(child);
	child = AwNode_nextChild(n);
    }

    if (AwNode_getType(n)==XML_ELEMENT) {
        for (i = 0; i < AwNode_getLevel(n); i++)  
	    putchar ('\t');
        printf ("- %s\n",AwNode_getInfo(n));
    }
	
}



int main (int argc, char **argv) {
   char buf[BUFSIZ];
   //int done;   
   AwTree *tree = NULL;
   AwString mesg,mesg2;

   size_t len = readBuffer (buf,sizeof(buf),stdin);
   //done = len < sizeof(buf);

   mesg = AwString_new (len);
   AwString_set (mesg,buf);
   
   printf ("Parsing.. umount message \n");
   tree = AwParser_umountMessage(mesg);
   
   printf ("Tree's info : \n");
   printf ("\troot %s maxdepth %d\n",(AwTree_getRoot(tree)==NULL)?"NULL": \
                                    AwNode_getInfo(AwTree_getRoot(tree)), \
				    AwTree_getMaxDepth(tree));

   printf ("\tlast %s depth %d\n",(AwTree_getLast(tree)==NULL)?"NULL": \
                                    AwNode_getInfo(AwTree_getLast(tree)), \
                                    AwTree_getDepth(tree));

   showTree(AwTree_getRoot(tree));
   putchar('\n');

   printf ("Building the message protocol \n");
   mesg2 = AwParser_mountMessage(tree);
   printf ("%s\n",(char *)mesg2); 
   
   AwParser_freeTree(tree);
   putchar ('\n');

    return 0;
  
}
