/* --------------------------------------------------------
 ** Header file fron an implementation of a dynamic list. 
 **
 ** Author : Manuele Kirsch Pinheiro
 ** Project CEMT - II/UFRGS - Opera Group/INRIA
 ** Finance by CNPq(Brazil)/INRIA(France) Cooperation
 **
 ** Date : 24 / Oct / 2001
 **
 ** $Id: list.h,v 1.2 2001/10/25 09:00:14 kirschpi Exp $
 ** $Revision: 1.2 $
 ** --------------------------------------------------- 
 */

#include <stdlib.h>		/* necessary includes */
#include <stdio.h>

#ifndef LIST_H
#define LIST_H

extern void * calloc (size_t count, size_t size);
extern void free (void *ptr);

#define LIST_OK 1		/* success flag */
#define LIST_FAILED -1		/* failed flag */

                       		/* some macro definitions */
#define LIST_CALLOC(count,size)	 calloc((count),(size))
#define LIST_FREE(ptr)  	free((ptr))


typedef struct _list {		/* list's structure */
    void **elements;		/* list's elements are pointers to void */
    int index;	   		/* index of the last element introduzed in the list */
    int next;     		/* next element to be returned */
    int size;      		/* list's size */
} List;



extern List * List_new (int lsize);     	/* creates a new list */
extern int List_delete (List *nlist);   	/* deletes a list */
extern int List_put (List *nlist, void *data);	/* introduce new elements to the list */
extern void * List_next (List *nlist);   	/* returns the next element in the list */
extern void List_reset (List *nlist);		/* resets the next element index in the list */
extern List * List_duplicate ( List * nlist );	/* duplicates the list size, keeping all its elements */

#endif 
