#include <stdlib.h>
#include "list.h"
#include "awstring.h"

int main (int argc, char **argv) {
    int i;
    int ret;
    char *str;
    List *nlist = NULL, *nlist2 = NULL;
    AwString data1, data2,data3;
    
    nlist = List_new (5);
    if (nlist== NULL) {
        fprintf (stderr, "Not enough memory\n");
        exit (1);
    }
  
    for (i=1; i<argc; i++) {
	data1 = AwString_new ( strlen (argv[i]));
	if (AwString_set (data1,argv[i]) < 0)
		fprintf (stdout, "Setting %s to a string failed \n",argv[i]);
	else {
        	fprintf (stdout, "Puting %s (list/string sizes: %d / %d) : ",data1,nlist->size, AwString_len (data1));
        	ret=List_put (nlist,(void *) data1);	
		if (ret<0) 
        	    fprintf (stdout, "Error on putting element %s\n",data1);	
		else
		    fprintf (stdout, "OK\n");			
	}	
    }
    
    do {
        data1 = (AwString) List_next (nlist);
        if (data1!=NULL) 
	    fprintf (stdout, "Element %s (list/string sizes: %d / %d)\n",data1,nlist->size, AwString_len (data1));	
	
    } while (data1 != NULL);

   
    fprintf (stdout, "Duplicating\n");
    List_reset (nlist);
    nlist2 = List_new (nlist->size);
    
    if (nlist2==NULL) {
	    fprintf (stderr, "Allocation failed - exiting\n");
	    exit (0);
    }
	    
    do {
	data1 = (AwString) List_next (nlist);
        if (data1!=NULL) {	
            data2 = AwString_new (AwString_len(data1));
	    if (AwString_copy (data2,data1) > 0) {
	        if (AwString_comp (data1,data2) > 0) {
		    fprintf (stdout,"Copy succeed - %s - Putting element ",data2);

		    if (List_put (nlist2,data2) > 0)
		        fprintf (stdout,"OK\n");
		    else
		        fprintf (stdout,"failed\n");
		} 
		else 
		    fprintf (stdout,"Copy failed!!\n");
	    }
	    else
		    fprintf (stdout,"Copy failed!\n");
	    
	}
    } while (data1 != NULL);


    /* cat */
    List_reset (nlist2);
    data1 = (AwString) List_next (nlist2);
    data2 = (AwString) List_next (nlist2);
    
    if (data1 != NULL && data2 != NULL) {
       data3 = AwString_cat (data1,data2);
       while (data2 != NULL && data3!=NULL) {
          data1 = data3;
          data2 = List_next (nlist2);
	  if (data2!=NULL) {
              data3 = AwString_cat (data1,data2);	  
	      free (data1);
	  }    
       }
    }
    else {
       if (data1!= NULL) {
           data3 = AwString_new (AwString_len(data1));
	   AwString_copy (data3,data1);
       }
    }

    fprintf (stdout,"Concatenated %s\n",data3);
    

    /* get / tof */
    List_reset (nlist2);
    do {
        data2 =(AwString) List_next (nlist2);
	if (data2!=NULL) {
	    str = AwString_get (data2);
	    i = (int) AwString_tof (data2);
	    fprintf (stdout, "%s ~ %d\n",str,i);
	}
    } while (data2!=NULL);
    
    
    /* freeing everything */
    fprintf (stdout, "Freeing everything ") ;
    List_reset (nlist);
    List_reset (nlist2);
    
    for (i=0; i<nlist->size && i<nlist->index ;i++) {
	fprintf (stdout,".");
	AwString_delete (List_next(nlist));
    } 

    for (i=0;i<nlist2->size && i<nlist->index ;i++)  {
	fprintf (stdout,".");
	AwString_delete (List_next(nlist2));
    } 
    
    fprintf (stdout,"\n");

    List_delete (nlist);
    List_delete (nlist2);
    
    return 0;
}

