#include <stdlib.h>
#include <stdio.h>
#include "awtree.h"

AwNode * makenode (int i, char **argv);
void freenode (AwNode *n);


/* node1 Root numchild child child ... */
int main (int argc, char **argv) {
	AwNode *n = NULL;
	AwNode *pai=NULL, *raiz=NULL;
	int nfilhos,i,index=1;
	
	
	/* ---------------- */
	printf ("\nDefining root node ---	");
	raiz = makenode(index++,argv);
	if (raiz==NULL)
		printf (" --- root node FAILED \n");
	else
		printf (" --- root node OK (%s) \n ",(char *)AwNode_getInfo(raiz));

	
	/* --------------------------- */
	printf ("\nBuilding the tree \n");
	n = raiz;
	pai = raiz;	

	while (index<argc) {	
	  nfilhos = atoi (argv[index++]);
	  printf ("Node %s (level %d) has %d children\n",AwNode_getInfo(n),AwNode_getLevel(n),nfilhos);	
	  i = index;
	  
 	  while (nfilhos>0) {
		printf ("Adding to %s child - ",AwNode_getInfo(pai));
		n = makenode(i,argv);
		printf ("- child %s ",AwNode_getInfo(n));
		nfilhos--;
		i += 2;

		if (AwNode_putChild(pai,n)<0)
			printf (" --- put FAILED \n");
		else {
			printf (" --- put OK (node father %s) \n ",AwNode_getInfo(AwNode_getFather(n)));
		}	
	  }	  
	}
	
	/* -------------------------- */	
	printf ("\nFreeing --- ");	
	freenode (raiz);	
	
		
	return 0;
}



AwNode * makenode (int i, char **argv) {
	AwNode *n;
	AwString str;
	
	printf ("\nArg %d %s\n\n",i,argv[i]);
	
	/* ---------------- */
	printf ("Creating node --- ");
	n = AwNode_new (5,5,5);
	if (n==NULL) {
		printf (" --- FAILED \n");
		exit (0);
	}	
	else
		printf (" --- OK \n");

	/* ------------------------ */
	printf ("NODE : addr %#lX info %#lX chd %#lX attr %#lX father %#lX level %d infosize %d \n", \
			n,n->info,n->children,n->attributes,n->father,n->level,n->infosize);
	

	/* --------------------- */
	printf ("Defining node --- ");
	str = AwString_new (strlen(argv[i]));
	if (str==NULL) {
		printf (" --- FAILED \n");
		exit (0);
	}
	printf ("copying info ");
	if (AwString_set (str,argv[i]) < 0) 
		printf (" --- FAILED \n");
	else
		printf (" %s ",(char *)str);
	printf ("- setting node - ");
	if (AwNode_setInfo (n,str)<0)
		printf (" --- FAILED \n");
	else
		printf (" --- OK (%s) \n ",(char *)AwNode_getInfo(n));

	AwString_delete (str);

	return n;
}

void freenode (AwNode *n) {
	AwNode *ch=NULL;
	
	if (n!=NULL) {
		printf ("Deleting children ");
		AwNode_resetChildren (n);
		do {
			ch = AwNode_nextChild (n);
			if (ch!=NULL) printf ("\n ** %s ** \n",AwNode_getInfo(ch));	
			freenode (ch);		
		} while (ch!=NULL);
		printf ("\nDeleting node --- ");
		if (AwNode_delete (n)<0)
			printf (" --- FAILED \n");
		else
			printf (" --- OK \n");
	}
}

