#include <string.h>
#include <stdlib.h>
#include <stdio.h>

#include "awtree.h"

AwNode * readnode (AwNode *pai);
AwNode * makenode (char *s); 
void addattr (AwNode *n, char *s); 
void read (char *s, int size);
void freenode (AwNode *n);

int main (int argc, char **argv) {
	AwNode *raiz=NULL,*pai=NULL,*n=NULL;
	char s[12];
	
	do {
		printf ("\nNode? (y|n) ");
		//fgets(s,128,stdin);
		read (s,128);
		s[1]='\0';
		if (strcmp(s,"n")!=0) {
			n = readnode(pai);
			if (raiz==NULL) {
				raiz = n;
			}
		}
	} while (s[0]!='n');

	freenode (raiz);

	return 0;	
}

void freenode (AwNode *n) {
	AwNode *child=NULL;
	AwPair *atr=NULL;
	
	printf ("Freeing node %s (father %s) \n",AwNode_getInfo(n), \
			   (AwNode_getFather(n)==NULL)?"NULL": \
			    AwNode_getInfo(AwNode_getFather(n)) );
	
	AwNode_resetAttributes (n);
	atr = AwNode_nextAttribute (n);
	while (atr!=NULL) {
		printf ("\tAttribute %s=%s ",AwPair_getName(atr),AwPair_getValue(atr));
		if (AwPair_delete(atr)<0)
			printf (" - FREE FAILED \n");
		else
			printf (" - FREE OK\n");
		atr = AwNode_nextAttribute (n);
	}

	AwNode_resetChildren (n);
	child = AwNode_nextChild(n);
	while (child!=NULL) {
		freenode(child);
		child = AwNode_nextChild(n);
	}
		
}

AwNode * readnode (AwNode *pai) {
	AwNode *n;
	AwPair *atr;
	AwNode *child;
	char s[128];
	int i;
	
	printf ("\nNode info: ");
	//fgets(s,128,stdin);
	read (s,128);
	
	n = makenode (s);
	printf ("Node %s \n",AwNode_getInfo(n));

	
	printf ("\nNo. of attributes: ");
	//fgets(s,128,stdin);
	read (s,128);
	i = atoi (s);
	while (i>0) {
		printf ("\nNode attribute (name value): ");
	//	fgets(s,128,stdin);
		read (s,128);
		addattr (n,s);
		i--;
	}	
		
	AwNode_resetAttributes (n);
	atr = AwNode_nextAttribute (n);
	while (atr!=NULL) {
		printf ("\tnode attribute %s=%s",AwPair_getName(atr),AwPair_getValue(atr));
		atr = AwNode_nextAttribute(n);
	}
	
	printf ("\nSetting father..");
        if (AwNode_setFather (n,pai) < 0)
		printf (" FAILED \n");
	else {
		if (pai!=NULL)	
			printf (" OK (%s)\n",AwNode_getInfo(pai));
		else 
			printf ("OK \n");	
	}
	
	//le numero de filhos
	printf ("No. of children : ");
	//fgets(s,128,stdin);
	read (s,128);
	i = atoi (s);
	while (i>0) {
		child = readnode (n);
		if (AwNode_putChild(n,child) < 0)
			printf (" Put Child FAILED\n");
		else
			printf (" Put child %s OK\n",AwNode_getInfo(child));
		i--;
	}

	return n ;		
			
}


AwNode * makenode (char *s) {
	AwNode *n;
	AwString i;

	i = AwString_new (strlen(s));
	AwString_set (i,s);
	printf ("getting info %s\n",i);
	
	n = AwNode_new (10,10,AwString_len(i));
	AwNode_setInfo (n,i);
	AwString_delete (i);
	return n;
}

void addattr (AwNode *n, char *s) {
	AwString nm,vl;
	AwPair *p;
	char *pnm,*pvl;

	pnm = s;
	pvl = strchr (s,' ');
	pvl[0]='\0';
	pvl++;
	
	printf ("name %s value %s\n",pnm,pvl);
	
	nm = AwString_new (strlen(pnm));
	vl = AwString_new (strlen(pvl));
	AwString_set (nm,pnm);
	AwString_set (vl,pvl);
	
	p = AwPair_new (AwString_len(nm),AwString_len(vl));
	AwPair_setName(p,nm);
	AwPair_setValue(p,vl);
	AwNode_putAttribute (n,p);
	
	AwString_delete (nm);
	AwString_delete (vl);
}

void read (char *s, int size) {
	int l=0;
	fgets(s,size,stdin);
	l= strlen(s);
	//printf ("readed %d last #%c#%c# - ",l,s[l-1],s[l]);		
	s[l-1]='\0';
	//printf (" #%s#\n",s);
}
