#include "awtree.h"

extern int AwPair_setName (AwPair *pair, AwString name);        /* sets the name attribute from the pair  */
extern AwString AwPair_getName (AwPair *pair);                  /* gets the name attribute from the pair */
extern int AwPair_setValue (AwPair *pair, AwString value);      /* sets the value attribute from the pair */
extern AwString AwPair_getValue (AwPair *pair);                 /* gets the value attribute from the pair */



int main (int argc, char ** argv) {
	AwString nm,vl;
	AwPair *p;
	List *l;
	int i,ret;
	
	l = List_new (3);
	if (l==NULL) {
		printf ("Allocation error \n");
		exit (0);
	}
	
	for (i=1;i<argc;i++) {
		printf ("Getting information - ");
		nm = AwString_new (strlen(argv[i]));		
		vl = AwString_new (strlen(argv[i+1]));
		if (nm==NULL || vl==NULL) {
			printf ("Allocation error \n");
			exit (0);
		}
		ret = 1;		
		ret = AwString_set (nm,argv[i++]);
		ret *= AwString_set (vl,argv[i]);
		if (ret < 0)
			printf (" FAILED \n");
		else {
			printf ("%s and %s - ",nm,vl);
			printf ("Putting in the pair ");
			p = AwPair_new (AwString_len(nm),AwString_len(vl));
			if (p==NULL) 
				printf ("FAILED \n");
			else {
				ret = 1;
				ret =  AwPair_setName(p,nm);
				ret *= AwPair_setValue (p,vl);
				if (ret < 0)
					printf (" FAILED \n");
				else {
					printf (" OK \n");
					List_put (l, (void *) p);
				}
			}
		}	
		AwString_delete (nm);
		AwString_delete (vl);
	}
	
	List_reset (l);
	
	do {
		p = List_next(l);
		if (p!=NULL) {
			printf ("Getting pair %s,%s \n", (char *) AwPair_getName(p), (char *) AwPair_getValue(p));
			AwPair_delete (p);
		}
	}while (p!=NULL);

	List_delete (l);
	
	return 0;
}

